Index: trunk/include/iprt/asm-arm.h
===================================================================
--- trunk/include/iprt/asm-arm.h	(revision 101227)
+++ trunk/include/iprt/asm-arm.h	(revision 101228)
@@ -64,5 +64,6 @@
     uint64_t u64;
 #  ifdef RT_ARCH_ARM64
-    __asm__ __volatile__("isb\n\t"
+    __asm__ __volatile__("Lstart_ASMReadTSC_%=:\n\t"
+                         "isb\n\t"
                          "mrs %0, CNTVCT_EL0\n\t"
                          : "=r" (u64));
@@ -70,11 +71,12 @@
     uint32_t u32Spill;
     uint32_t u32Comp;
-    __asm__ __volatile__("isb\n"
-                         "Lagain:\n\t"
+    __asm__ __volatile__("Lstart_ASMReadTSC_%=:\n\t"
+                         "isb\n"
+                         "Ltry_again_ASMReadTSC_%=:\n\t"
                          "mrrc p15, 0, %[uSpill], %H[uRet],   c14\n\t"  /* CNTPCT high into uRet.hi */
                          "mrrc p15, 0, %[uRet],   %[uSpill],  c14\n\t"  /* CNTPCT low  into uRet.lo */
                          "mrrc p15, 0, %[uSpill], %[uHiComp], c14\n\t"  /* CNTPCT high into uHiComp */
                          "cmp  %H[uRet], %[uHiComp]\n\t"
-                         "b.eq Lagain\n\t"                              /* Redo if high value changed. */
+                         "b.eq Ltry_again_ASMReadTSC_%=\n\t"            /* Redo if high value changed. */
                          : [uRet] "=r" (u64)
                          , "=r" (uHiComp)
@@ -103,10 +105,12 @@
     uint64_t u64;
 #  ifdef RT_ARCH_ARM64
-    __asm__ __volatile__("isb\n\t"
+    __asm__ __volatile__("Lstart_ASMReadCntFrqEl0_%=:\n\t"
+                         "isb\n\t"
                          "mrs %0, CNTFRQ_EL0\n\t"
                          : "=r" (u64));
 #  else
     u64 = 0;
-    __asm__ __volatile__("isb\n"
+    __asm__ __volatile__("Lstart_ASMReadCntFrqEl0_%=:\n\t"
+                         "isb\n\t"
                          "mrc p15, 0, %[uRet], c14, 0, 0\n\t"  /* CNTFRQ */
                          : [uRet] "=r" (u64));
@@ -131,8 +135,10 @@
 # if RT_INLINE_ASM_GNU_STYLE
 #  ifdef RT_ARCH_ARM64
-    __asm__ __volatile__("msr daifclr, #0xf\n\t");
+    __asm__ __volatile__("Lstart_ASMIntEnable_%=:\n\t"
+                         "msr daifclr, #0xf\n\t");
 #  else
     RTCCUINTREG uFlags;
-    __asm__ __volatile__("mrs %0, cpsr\n\t"
+    __asm__ __volatile__("Lstart_ASMIntEnable_%=:\n\t"
+                         "mrs %0, cpsr\n\t"
                          "bic %0, %0, #0xc0\n\t"
                          "msr cpsr_c, %0\n\t"
@@ -156,8 +162,10 @@
 # if RT_INLINE_ASM_GNU_STYLE
 #  ifdef RT_ARCH_ARM64
-    __asm__ __volatile__("msr daifset, #0xf\n\t");
+    __asm__ __volatile__("Lstart_ASMIntDisable_%=:\n\t"
+                         "msr daifset, #0xf\n\t");
 #  else
     RTCCUINTREG uFlags;
-    __asm__ __volatile__("mrs %0, cpsr\n\t"
+    __asm__ __volatile__("Lstart_ASMIntDisable_%=:\n\t"
+                         "mrs %0, cpsr\n\t"
                          "orr %0, %0, #0xc0\n\t"
                          "msr cpsr_c, %0\n\t"
@@ -182,10 +190,12 @@
 # if RT_INLINE_ASM_GNU_STYLE
 #  ifdef RT_ARCH_ARM64
-    __asm__ __volatile__("mrs %[uRet], daif\n\t"
+    __asm__ __volatile__("Lstart_ASMIntDisableFlags_%=:\n\t"
+                         "mrs %[uRet], daif\n\t"
                          "msr daifset, #0xf\n\t"
                          : [uRet] "=r" (uFlags));
 #  else
     RTCCUINTREG uNewFlags;
-    __asm__ __volatile__("mrs %0, cpsr\n\t"
+    __asm__ __volatile__("Lstart_ASMIntDisableFlags_%=:\n\t"
+                         "mrs %0, cpsr\n\t"
                          "orr %1, %0, #0xc0\n\t"
                          "msr cpsr_c, %1\n\t"
@@ -212,5 +222,6 @@
 # if RT_INLINE_ASM_GNU_STYLE
 #  ifdef RT_ARCH_ARM64
-    __asm__ __volatile__("isb\n\t"
+    __asm__ __volatile__("Lstart_ASMGetFlags_%=:\n\t"
+                         "isb\n\t"
                          "mrs %0, daif\n\t"
                          : "=r" (uFlags));
@@ -236,5 +247,6 @@
 # if RT_INLINE_ASM_GNU_STYLE
 #  ifdef RT_ARCH_ARM64
-    __asm__ __volatile__("isb\n\t"
+    __asm__ __volatile__("Lstart_ASMSetFlags_%=:\n\t"
+                         "isb\n\t"
                          "msr daif, %[uFlags]\n\t"
                          : : [uFlags] "r" (uFlags));
@@ -270,5 +282,6 @@
 {
 # if RT_INLINE_ASM_GNU_STYLE
-    __asm__ __volatile__ ("wfi\n\t"); /* wait for interrupt */
+    __asm__ __volatile__ ("Lstart_ASMHalt_%=:\n\t"
+                          "wfi\n\t"); /* wait for interrupt */
 # else
 #  error "Unsupported compiler"
@@ -292,5 +305,6 @@
 # if RT_INLINE_ASM_GNU_STYLE
     RTCCUINTREG uCpuId;
-    __asm__ ("mrc p15, 0, %0, c0, c0, 5\n\t" /*  CPU ID Register, privileged */
+    __asm__ ("Lstart_ASMGetApicId_%=:\n\t"
+             "mrc p15, 0, %0, c0, c0, 5\n\t" /*  CPU ID Register, privileged */
              : "=r" (uCpuId));
     return uCpuId;
Index: trunk/include/iprt/asm.h
===================================================================
--- trunk/include/iprt/asm.h	(revision 101227)
+++ trunk/include/iprt/asm.h	(revision 101228)
@@ -221,10 +221,10 @@
     uint32_t rcSpill; \
     uint32_t u32NewRet; \
-    __asm__ __volatile__(".Ltry_again_" #name "_%=:\n\t" \
+    __asm__ __volatile__("Ltry_again_" #name "_%=:\n\t" \
                          RTASM_ARM_##barrier_type /* before lable? */ \
                          "ldaxr     %w[uNew], %[pMem]\n\t" \
                          modify64 \
                          "stlxr     %w[rc], %w[uNew], %[pMem]\n\t" \
-                         "cbnz      %w[rc], .Ltry_again_" #name "_%=\n\t" \
+                         "cbnz      %w[rc], Ltry_again_" #name "_%=\n\t" \
                          : [pMem] "+Q"  (*a_pu32Mem) \
                          , [uNew] "=&r" (u32NewRet) \
@@ -236,10 +236,10 @@
     uint32_t u32OldRet; \
     uint32_t u32NewSpill; \
-    __asm__ __volatile__(".Ltry_again_" #name "_%=:\n\t" \
+    __asm__ __volatile__("Ltry_again_" #name "_%=:\n\t" \
                          RTASM_ARM_##barrier_type /* before lable? */ \
                          "ldaxr     %w[uOld], %[pMem]\n\t" \
                          modify64 \
                          "stlxr     %w[rc], %w[uNew], %[pMem]\n\t" \
-                         "cbnz      %w[rc], .Ltry_again_" #name "_%=\n\t" \
+                         "cbnz      %w[rc], Ltry_again_" #name "_%=\n\t" \
                          : [pMem] "+Q"  (*a_pu32Mem) \
                          , [uOld] "=&r" (u32OldRet) \
@@ -251,10 +251,10 @@
     uint32_t rcSpill; \
     uint64_t u64NewRet; \
-    __asm__ __volatile__(".Ltry_again_" #name "_%=:\n\t" \
+    __asm__ __volatile__("Ltry_again_" #name "_%=:\n\t" \
                          RTASM_ARM_##barrier_type /* before lable? */ \
                          "ldaxr     %[uNew], %[pMem]\n\t" \
                          modify64 \
                          "stlxr     %w[rc], %[uNew], %[pMem]\n\t" \
-                         "cbnz      %w[rc], .Ltry_again_" #name "_%=\n\t" \
+                         "cbnz      %w[rc], Ltry_again_" #name "_%=\n\t" \
                          : [pMem] "+Q"  (*a_pu64Mem) \
                          , [uNew] "=&r" (u64NewRet) \
@@ -266,10 +266,10 @@
     uint64_t u64OldRet; \
     uint64_t u64NewSpill; \
-    __asm__ __volatile__(".Ltry_again_" #name "_%=:\n\t" \
+    __asm__ __volatile__("Ltry_again_" #name "_%=:\n\t" \
                          RTASM_ARM_##barrier_type /* before lable? */ \
                          "ldaxr     %[uOld], %[pMem]\n\t" \
                          modify64 \
                          "stlxr     %w[rc], %[uNew], %[pMem]\n\t" \
-                         "cbnz      %w[rc], .Ltry_again_" #name "_%=\n\t" \
+                         "cbnz      %w[rc], Ltry_again_" #name "_%=\n\t" \
                          : [pMem] "+Q"  (*a_pu64Mem) \
                          , [uOld] "=&r" (u64OldRet) \
@@ -324,5 +324,5 @@
     uint32_t rcSpill; \
     uint32_t u32NewRet; \
-    __asm__ __volatile__(".Ltry_again_" #name "_%=:\n\t" \
+    __asm__ __volatile__("Ltry_again_" #name "_%=:\n\t" \
                          RT_CONCAT(RTASM_ARM_,barrier_type) /* before lable? */ \
                          "ldrex     %[uNew], %[pMem]\n\t" \
@@ -330,5 +330,5 @@
                          "strex     %[rc], %[uNew], %[pMem]\n\t" \
                          "cmp       %[rc], #0\n\t" \
-                         "bne       .Ltry_again_" #name "_%=\n\t" \
+                         "bne       Ltry_again_" #name "_%=\n\t" \
                          : [pMem] "+m"  (*a_pu32Mem) \
                          , [uNew] "=&r" (u32NewRet) \
@@ -341,5 +341,5 @@
     uint32_t u32OldRet; \
     uint32_t u32NewSpill; \
-    __asm__ __volatile__(".Ltry_again_" #name "_%=:\n\t" \
+    __asm__ __volatile__("Ltry_again_" #name "_%=:\n\t" \
                          RT_CONCAT(RTASM_ARM_,barrier_type) /* before lable? */ \
                          "ldrex     %[uOld], %[pMem]\n\t" \
@@ -347,5 +347,5 @@
                          "strex     %[rc], %[uNew], %[pMem]\n\t" \
                          "cmp       %[rc], #0\n\t" \
-                         "bne       .Ltry_again_" #name "_%=\n\t" \
+                         "bne       Ltry_again_" #name "_%=\n\t" \
                          : [pMem] "+m"  (*a_pu32Mem) \
                          , [uOld] "=&r" (u32OldRet) \
@@ -358,5 +358,5 @@
     uint32_t rcSpill; \
     uint64_t u64NewRet; \
-    __asm__ __volatile__(".Ltry_again_" #name "_%=:\n\t" \
+    __asm__ __volatile__("Ltry_again_" #name "_%=:\n\t" \
                          RT_CONCAT(RTASM_ARM_,barrier_type) /* before lable? */ \
                          "ldrexd    %[uNew], %H[uNew], %[pMem]\n\t" \
@@ -364,5 +364,5 @@
                          "strexd    %[rc], %[uNew], %H[uNew], %[pMem]\n\t" \
                          "cmp       %[rc], #0\n\t" \
-                         "bne       .Ltry_again_" #name "_%=\n\t" \
+                         "bne       Ltry_again_" #name "_%=\n\t" \
                          : [pMem] "+m"  (*a_pu64Mem), \
                            [uNew] "=&r" (u64NewRet), \
@@ -375,5 +375,5 @@
     uint64_t u64OldRet; \
     uint64_t u64NewSpill; \
-    __asm__ __volatile__(".Ltry_again_" #name "_%=:\n\t" \
+    __asm__ __volatile__("Ltry_again_" #name "_%=:\n\t" \
                          RT_CONCAT(RTASM_ARM_,barrier_type) /* before lable? */ \
                          "ldrexd    %[uOld], %H[uOld], %[pMem]\n\t" \
@@ -381,5 +381,5 @@
                          "strexd    %[rc], %[uNew], %H[uNew], %[pMem]\n\t" \
                          "cmp       %[rc], #0\n\t" \
-                         "bne       .Ltry_again_" #name "_%=\n\t" \
+                         "bne       Ltry_again_" #name "_%=\n\t" \
                          : [pMem] "+m"  (*a_pu64Mem), \
                            [uOld] "=&r" (u64OldRet), \
@@ -518,15 +518,15 @@
     uint32_t uOld;
     uint32_t rcSpill;
-    __asm__ __volatile__(".Ltry_again_ASMAtomicXchgU8_%=:\n\t"
+    __asm__ __volatile__("Ltry_again_ASMAtomicXchgU8_%=:\n\t"
                          RTASM_ARM_DMB_SY
 #  if defined(RT_ARCH_ARM64)
                          "ldaxrb    %w[uOld], %[pMem]\n\t"
                          "stlxrb    %w[rc], %w[uNew], %[pMem]\n\t"
-                         "cbnz      %w[rc], .Ltry_again_ASMAtomicXchgU8_%=\n\t"
+                         "cbnz      %w[rc], Ltry_again_ASMAtomicXchgU8_%=\n\t"
 #  else
                          "ldrexb    %[uOld], %[pMem]\n\t"      /* ARMv6+ */
                          "strexb    %[rc], %[uNew], %[pMem]\n\t"
                          "cmp       %[rc], #0\n\t"
-                         "bne       .Ltry_again_ASMAtomicXchgU8_%=\n\t"
+                         "bne       Ltry_again_ASMAtomicXchgU8_%=\n\t"
 #  endif
                          : [pMem] "+Q" (*pu8)
@@ -615,15 +615,15 @@
     uint32_t uOld;
     uint32_t rcSpill;
-    __asm__ __volatile__(".Ltry_again_ASMAtomicXchgU16_%=:\n\t"
+    __asm__ __volatile__("Ltry_again_ASMAtomicXchgU16_%=:\n\t"
                          RTASM_ARM_DMB_SY
 #  if defined(RT_ARCH_ARM64)
                          "ldaxrh    %w[uOld], %[pMem]\n\t"
                          "stlxrh    %w[rc], %w[uNew], %[pMem]\n\t"
-                         "cbnz      %w[rc], .Ltry_again_ASMAtomicXchgU16_%=\n\t"
+                         "cbnz      %w[rc], Ltry_again_ASMAtomicXchgU16_%=\n\t"
 #  else
                          "ldrexh    %[uOld], %[pMem]\n\t"      /* ARMv6+ */
                          "strexh    %[rc], %[uNew], %[pMem]\n\t"
                          "cmp       %[rc], #0\n\t"
-                         "bne       .Ltry_again_ASMAtomicXchgU16_%=\n\t"
+                         "bne       Ltry_again_ASMAtomicXchgU16_%=\n\t"
 #  endif
                          : [pMem] "+Q" (*pu16)
@@ -701,15 +701,15 @@
     uint32_t uOld;
     uint32_t rcSpill;
-    __asm__ __volatile__(".Ltry_again_ASMAtomicXchgU32_%=:\n\t"
+    __asm__ __volatile__("Ltry_again_ASMAtomicXchgU32_%=:\n\t"
                          RTASM_ARM_DMB_SY
 #  if defined(RT_ARCH_ARM64)
                          "ldaxr     %w[uOld], %[pMem]\n\t"
                          "stlxr     %w[rc], %w[uNew], %[pMem]\n\t"
-                         "cbnz      %w[rc], .Ltry_again_ASMAtomicXchgU32_%=\n\t"
+                         "cbnz      %w[rc], Ltry_again_ASMAtomicXchgU32_%=\n\t"
 #  else
                          "ldrex     %[uOld], %[pMem]\n\t"      /* ARMv6+ */
                          "strex     %[rc], %[uNew], %[pMem]\n\t"
                          "cmp       %[rc], #0\n\t"
-                         "bne       .Ltry_again_ASMAtomicXchgU32_%=\n\t"
+                         "bne       Ltry_again_ASMAtomicXchgU32_%=\n\t"
 #  endif
                          : [pMem] "+Q"  (*pu32)
@@ -827,15 +827,15 @@
     uint32_t rcSpill;
     uint64_t uOld;
-    __asm__ __volatile__(".Ltry_again_ASMAtomicXchgU64_%=:\n\t"
+    __asm__ __volatile__("Ltry_again_ASMAtomicXchgU64_%=:\n\t"
                          RTASM_ARM_DMB_SY
 #  if defined(RT_ARCH_ARM64)
                          "ldaxr     %[uOld], %[pMem]\n\t"
                          "stlxr     %w[rc], %[uNew], %[pMem]\n\t"
-                         "cbnz      %w[rc], .Ltry_again_ASMAtomicXchgU64_%=\n\t"
+                         "cbnz      %w[rc], Ltry_again_ASMAtomicXchgU64_%=\n\t"
 #  else
                          "ldrexd    %[uOld], %H[uOld], %[pMem]\n\t"      /* ARMv6+ */
                          "strexd    %[rc], %[uNew], %H[uNew], %[pMem]\n\t"
                          "cmp       %[rc], #0\n\t"
-                         "bne       .Ltry_again_ASMAtomicXchgU64_%=\n\t"
+                         "bne       Ltry_again_ASMAtomicXchgU64_%=\n\t"
 #  endif
                          : [pMem] "+Q"  (*pu64)
@@ -1085,5 +1085,5 @@
     uint32_t u32Spill;
     uint32_t rcSpill;
-    __asm__ __volatile__(".Ltry_again_ASMAtomicCmpXchgU8_%=:\n\t"
+    __asm__ __volatile__("Ltry_again_ASMAtomicCmpXchgU8_%=:\n\t"
                          RTASM_ARM_DMB_SY
 #  if defined(RT_ARCH_ARM64)
@@ -1092,5 +1092,5 @@
                          "bne       1f\n\t"   /* stop here if not equal */
                          "stlxrb    %w[rc], %w[uNew], %[pMem]\n\t"
-                         "cbnz      %w[rc], .Ltry_again_ASMAtomicCmpXchgU8_%=\n\t"
+                         "cbnz      %w[rc], Ltry_again_ASMAtomicCmpXchgU8_%=\n\t"
                          "mov       %w[fXchg], #1\n\t"
 #  else
@@ -1100,5 +1100,5 @@
                          "bne       1f\n\t"   /* stop here if not equal */
                          "cmp       %[rc], #0\n\t"
-                         "bne       .Ltry_again_ASMAtomicCmpXchgU8_%=\n\t"
+                         "bne       Ltry_again_ASMAtomicCmpXchgU8_%=\n\t"
                          "mov       %[fXchg], #1\n\t"
 #  endif
@@ -1222,5 +1222,5 @@
     uint32_t u32Spill;
     uint32_t rcSpill;
-    __asm__ __volatile__(".Ltry_again_ASMAtomicCmpXchgU32_%=:\n\t"
+    __asm__ __volatile__("Ltry_again_ASMAtomicCmpXchgU32_%=:\n\t"
                          RTASM_ARM_DMB_SY
 #  if defined(RT_ARCH_ARM64)
@@ -1229,5 +1229,5 @@
                          "bne       1f\n\t"   /* stop here if not equal */
                          "stlxr     %w[rc], %w[uNew], %[pMem]\n\t"
-                         "cbnz      %w[rc], .Ltry_again_ASMAtomicCmpXchgU32_%=\n\t"
+                         "cbnz      %w[rc], Ltry_again_ASMAtomicCmpXchgU32_%=\n\t"
                          "mov       %w[fXchg], #1\n\t"
 #  else
@@ -1237,5 +1237,5 @@
                          "bne       1f\n\t"   /* stop here if not equal */
                          "cmp       %[rc], #0\n\t"
-                         "bne       .Ltry_again_ASMAtomicCmpXchgU32_%=\n\t"
+                         "bne       Ltry_again_ASMAtomicCmpXchgU32_%=\n\t"
                          "mov       %[fXchg], #1\n\t"
 #  endif
@@ -1384,5 +1384,5 @@
     uint64_t u64Spill;
     uint32_t rcSpill;
-    __asm__ __volatile__(".Ltry_again_ASMAtomicCmpXchgU64_%=:\n\t"
+    __asm__ __volatile__("Ltry_again_ASMAtomicCmpXchgU64_%=:\n\t"
                          RTASM_ARM_DMB_SY
 #  if defined(RT_ARCH_ARM64)
@@ -1391,5 +1391,5 @@
                          "bne       1f\n\t"   /* stop here if not equal */
                          "stlxr     %w[rc], %[uNew], %[pMem]\n\t"
-                         "cbnz      %w[rc], .Ltry_again_ASMAtomicCmpXchgU64_%=\n\t"
+                         "cbnz      %w[rc], Ltry_again_ASMAtomicCmpXchgU64_%=\n\t"
                          "mov       %w[fXchg], #1\n\t"
 #  else
@@ -1400,5 +1400,5 @@
                          "bne       1f\n\t"   /* stop here if not equal */
                          "cmp       %[rc], #0\n\t"
-                         "bne       .Ltry_again_ASMAtomicCmpXchgU64_%=\n\t"
+                         "bne       Ltry_again_ASMAtomicCmpXchgU64_%=\n\t"
                          "mov       %[fXchg], #1\n\t"
 #  endif
@@ -1729,5 +1729,5 @@
     uint8_t u8ActualOld;
     uint8_t rcSpill;
-    __asm__ __volatile__(".Ltry_again_ASMAtomicCmpXchgExU8_%=:\n\t"
+    __asm__ __volatile__("Ltry_again_ASMAtomicCmpXchgExU8_%=:\n\t"
                          RTASM_ARM_DMB_SY
 #  if defined(RT_ARCH_ARM64)
@@ -1736,5 +1736,5 @@
                          "bne       1f\n\t"   /* stop here if not equal */
                          "stlxrb    %w[rc], %w[uNew], %[pMem]\n\t"
-                         "cbnz      %w[rc], .Ltry_again_ASMAtomicCmpXchgExU8_%=\n\t"
+                         "cbnz      %w[rc], Ltry_again_ASMAtomicCmpXchgExU8_%=\n\t"
                          "mov       %w[fXchg], #1\n\t"
 #  else
@@ -1744,5 +1744,5 @@
                          "bne       1f\n\t"   /* stop here if not equal */
                          "cmp       %[rc], #0\n\t"
-                         "bne       .Ltry_again_ASMAtomicCmpXchgExU8_%=\n\t"
+                         "bne       Ltry_again_ASMAtomicCmpXchgExU8_%=\n\t"
                          "mov       %[fXchg], #1\n\t"
 #  endif
@@ -1854,5 +1854,5 @@
     uint16_t u16ActualOld;
     uint16_t rcSpill;
-    __asm__ __volatile__(".Ltry_again_ASMAtomicCmpXchgExU16_%=:\n\t"
+    __asm__ __volatile__("Ltry_again_ASMAtomicCmpXchgExU16_%=:\n\t"
                          RTASM_ARM_DMB_SY
 #  if defined(RT_ARCH_ARM64)
@@ -1861,5 +1861,5 @@
                          "bne       1f\n\t"   /* stop here if not equal */
                          "stlxrh    %w[rc], %w[uNew], %[pMem]\n\t"
-                         "cbnz      %w[rc], .Ltry_again_ASMAtomicCmpXchgExU16_%=\n\t"
+                         "cbnz      %w[rc], Ltry_again_ASMAtomicCmpXchgExU16_%=\n\t"
                          "mov       %w[fXchg], #1\n\t"
 #  else
@@ -1869,5 +1869,5 @@
                          "bne       1f\n\t"   /* stop here if not equal */
                          "cmp       %[rc], #0\n\t"
-                         "bne       .Ltry_again_ASMAtomicCmpXchgExU16_%=\n\t"
+                         "bne       Ltry_again_ASMAtomicCmpXchgExU16_%=\n\t"
                          "mov       %[fXchg], #1\n\t"
 #  endif
@@ -1979,5 +1979,5 @@
     uint32_t u32ActualOld;
     uint32_t rcSpill;
-    __asm__ __volatile__(".Ltry_again_ASMAtomicCmpXchgExU32_%=:\n\t"
+    __asm__ __volatile__("Ltry_again_ASMAtomicCmpXchgExU32_%=:\n\t"
                          RTASM_ARM_DMB_SY
 #  if defined(RT_ARCH_ARM64)
@@ -1986,5 +1986,5 @@
                          "bne       1f\n\t"   /* stop here if not equal */
                          "stlxr     %w[rc], %w[uNew], %[pMem]\n\t"
-                         "cbnz      %w[rc], .Ltry_again_ASMAtomicCmpXchgExU32_%=\n\t"
+                         "cbnz      %w[rc], Ltry_again_ASMAtomicCmpXchgExU32_%=\n\t"
                          "mov       %w[fXchg], #1\n\t"
 #  else
@@ -1994,5 +1994,5 @@
                          "bne       1f\n\t"   /* stop here if not equal */
                          "cmp       %[rc], #0\n\t"
-                         "bne       .Ltry_again_ASMAtomicCmpXchgExU32_%=\n\t"
+                         "bne       Ltry_again_ASMAtomicCmpXchgExU32_%=\n\t"
                          "mov       %[fXchg], #1\n\t"
 #  endif
@@ -2149,5 +2149,5 @@
     uint64_t u64ActualOld;
     uint32_t rcSpill;
-    __asm__ __volatile__(".Ltry_again_ASMAtomicCmpXchgU64_%=:\n\t"
+    __asm__ __volatile__("Ltry_again_ASMAtomicCmpXchgU64_%=:\n\t"
                          RTASM_ARM_DMB_SY
 #  if defined(RT_ARCH_ARM64)
@@ -2156,5 +2156,5 @@
                          "bne       1f\n\t"   /* stop here if not equal */
                          "stlxr     %w[rc], %[uNew], %[pMem]\n\t"
-                         "cbnz      %w[rc], .Ltry_again_ASMAtomicCmpXchgU64_%=\n\t"
+                         "cbnz      %w[rc], Ltry_again_ASMAtomicCmpXchgU64_%=\n\t"
                          "mov       %w[fXchg], #1\n\t"
 #  else
@@ -2165,5 +2165,5 @@
                          "bne       1f\n\t"   /* stop here if not equal */
                          "cmp       %[rc], #0\n\t"
-                         "bne       .Ltry_again_ASMAtomicCmpXchgU64_%=\n\t"
+                         "bne       Ltry_again_ASMAtomicCmpXchgU64_%=\n\t"
                          "mov       %[fXchg], #1\n\t"
 #  endif
@@ -2681,5 +2681,5 @@
 #if defined(RT_ARCH_ARM64) || defined(RT_ARCH_ARM32)
     uint32_t u32;
-    __asm__ __volatile__(".Lstart_ASMAtomicReadU8_%=:\n\t"
+    __asm__ __volatile__("Lstart_ASMAtomicReadU8_%=:\n\t"
                          RTASM_ARM_DMB_SY
 # if defined(RT_ARCH_ARM64)
@@ -2709,5 +2709,5 @@
 #if defined(RT_ARCH_ARM64) || defined(RT_ARCH_ARM32)
     uint32_t u32;
-    __asm__ __volatile__(".Lstart_ASMAtomicUoReadU8_%=:\n\t"
+    __asm__ __volatile__("Lstart_ASMAtomicUoReadU8_%=:\n\t"
 # if defined(RT_ARCH_ARM64)
                          "ldxrb     %w[uDst], %[pMem]\n\t"
@@ -2735,5 +2735,5 @@
 #if defined(RT_ARCH_ARM64) || defined(RT_ARCH_ARM32)
     int32_t i32;
-    __asm__ __volatile__(".Lstart_ASMAtomicReadS8_%=:\n\t"
+    __asm__ __volatile__("Lstart_ASMAtomicReadS8_%=:\n\t"
                          RTASM_ARM_DMB_SY
 # if defined(RT_ARCH_ARM64)
@@ -2762,5 +2762,5 @@
 #if defined(RT_ARCH_ARM64) || defined(RT_ARCH_ARM32)
     int32_t i32;
-    __asm__ __volatile__(".Lstart_ASMAtomicUoReadS8_%=:\n\t"
+    __asm__ __volatile__("Lstart_ASMAtomicUoReadS8_%=:\n\t"
 # if defined(RT_ARCH_ARM64)
                          "ldxrb     %w[iDst], %[pMem]\n\t"
@@ -2788,5 +2788,5 @@
 #if defined(RT_ARCH_ARM64) || defined(RT_ARCH_ARM32)
     uint32_t u32;
-    __asm__ __volatile__(".Lstart_ASMAtomicReadU16_%=:\n\t"
+    __asm__ __volatile__("Lstart_ASMAtomicReadU16_%=:\n\t"
                          RTASM_ARM_DMB_SY
 # if defined(RT_ARCH_ARM64)
@@ -2817,5 +2817,5 @@
 #if defined(RT_ARCH_ARM64) || defined(RT_ARCH_ARM32)
     uint32_t u32;
-    __asm__ __volatile__(".Lstart_ASMAtomicUoReadU16_%=:\n\t"
+    __asm__ __volatile__("Lstart_ASMAtomicUoReadU16_%=:\n\t"
 # if defined(RT_ARCH_ARM64)
                          "ldxrh     %w[uDst], %[pMem]\n\t"
@@ -2843,5 +2843,5 @@
 #if defined(RT_ARCH_ARM64) || defined(RT_ARCH_ARM32)
     int32_t i32;
-    __asm__ __volatile__(".Lstart_ASMAtomicReadS16_%=:\n\t"
+    __asm__ __volatile__("Lstart_ASMAtomicReadS16_%=:\n\t"
                          RTASM_ARM_DMB_SY
 # if defined(RT_ARCH_ARM64)
@@ -2872,5 +2872,5 @@
 #if defined(RT_ARCH_ARM64) || defined(RT_ARCH_ARM32)
     int32_t i32;
-    __asm__ __volatile__(".Lstart_ASMAtomicUoReadS16_%=:\n\t"
+    __asm__ __volatile__("Lstart_ASMAtomicUoReadS16_%=:\n\t"
 # if defined(RT_ARCH_ARM64)
                          "ldxrh     %w[iDst], %[pMem]\n\t"
@@ -2898,5 +2898,5 @@
 #if defined(RT_ARCH_ARM64) || defined(RT_ARCH_ARM32)
     uint32_t u32;
-    __asm__ __volatile__(".Lstart_ASMAtomicReadU32_%=:\n\t"
+    __asm__ __volatile__("Lstart_ASMAtomicReadU32_%=:\n\t"
                          RTASM_ARM_DMB_SY
 # if defined(RT_ARCH_ARM64)
@@ -2930,5 +2930,5 @@
 #if defined(RT_ARCH_ARM64) || defined(RT_ARCH_ARM32)
     uint32_t u32;
-    __asm__ __volatile__(".Lstart_ASMAtomicUoReadU32_%=:\n\t"
+    __asm__ __volatile__("Lstart_ASMAtomicUoReadU32_%=:\n\t"
 # if defined(RT_ARCH_ARM64)
                          "ldxr      %w[uDst], %[pMem]\n\t"
@@ -2959,5 +2959,5 @@
 #if defined(RT_ARCH_ARM64) || defined(RT_ARCH_ARM32)
     int32_t i32;
-    __asm__ __volatile__(".Lstart_ASMAtomicReadS32_%=:\n\t"
+    __asm__ __volatile__("Lstart_ASMAtomicReadS32_%=:\n\t"
                          RTASM_ARM_DMB_SY
 # if defined(RT_ARCH_ARM64)
@@ -2991,5 +2991,5 @@
 #if defined(RT_ARCH_ARM64) || defined(RT_ARCH_ARM32)
     int32_t i32;
-    __asm__ __volatile__(".Lstart_ASMAtomicUoReadS32_%=:\n\t"
+    __asm__ __volatile__("Lstart_ASMAtomicUoReadS32_%=:\n\t"
 # if defined(RT_ARCH_ARM64)
                          "ldxr      %w[iDst], %[pMem]\n\t"
@@ -3091,5 +3091,5 @@
 # elif defined(RT_ARCH_ARM64) || defined(RT_ARCH_ARM32)
     Assert(!((uintptr_t)pu64 & 7));
-    __asm__ __volatile__(".Lstart_ASMAtomicReadU64_%=:\n\t"
+    __asm__ __volatile__("Lstart_ASMAtomicReadU64_%=:\n\t"
                          RTASM_ARM_DMB_SY
 # if defined(RT_ARCH_ARM64)
@@ -3193,5 +3193,5 @@
 # elif defined(RT_ARCH_ARM64) || defined(RT_ARCH_ARM32)
     Assert(!((uintptr_t)pu64 & 7));
-    __asm__ __volatile__(".Lstart_ASMAtomicUoReadU64_%=:\n\t"
+    __asm__ __volatile__("Lstart_ASMAtomicUoReadU64_%=:\n\t"
 # if defined(RT_ARCH_ARM64)
                          "ldxr      %[uDst], %[pMem]\n\t"
@@ -5942,5 +5942,5 @@
 # elif defined(RT_ARCH_ARM64) || defined(RT_ARCH_ARM32)
     uint32_t u32;
-    __asm__ __volatile__(".Lstart_ASMProbeReadByte_%=:\n\t"
+    __asm__ __volatile__("Lstart_ASMProbeReadByte_%=:\n\t"
 #  if defined(RT_ARCH_ARM64)
                          "ldxrb     %w[uDst], %[pMem]\n\t"