Index: trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/Application/PrmInfo/PrmInfo.c
===================================================================
--- trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/Application/PrmInfo/PrmInfo.c	(revision 101283)
+++ trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/Application/PrmInfo/PrmInfo.c	(revision 101291)
@@ -494,5 +494,5 @@
         "%a - %a: An error occurred creating a context buffer for handler %g\n",
         gEfiCallerBaseName,
-        __FUNCTION__,
+        __func__,
         HandlerContext->Guid
         ));
@@ -629,5 +629,5 @@
       "%a - %a: An error occurred during PRM module discovery (%r)\n",
       gEfiCallerBaseName,
-      __FUNCTION__,
+      __func__,
       Status
       ));
@@ -720,5 +720,5 @@
       "%a - %a: An error occurred parsing user-provided arguments (%r)\n",
       gEfiCallerBaseName,
-      __FUNCTION__,
+      __func__,
       Status
       ));
Index: trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/Library/DxePrmContextBufferLib/DxePrmContextBufferLib.c
===================================================================
--- trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/Library/DxePrmContextBufferLib/DxePrmContextBufferLib.c	(revision 101283)
+++ trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/Library/DxePrmContextBufferLib/DxePrmContextBufferLib.c	(revision 101291)
@@ -41,5 +41,5 @@
   UINTN  Index;
 
-  DEBUG ((DEBUG_INFO, "    %a %a - Entry.\n", _DBGMSGID_, __FUNCTION__));
+  DEBUG ((DEBUG_INFO, "    %a %a - Entry.\n", _DBGMSGID_, __func__));
 
   if ((HandlerGuid == NULL) || (ModuleContextBuffers == NULL) || (ContextBuffer == NULL)) {
@@ -90,5 +90,5 @@
   CONST PRM_CONTEXT_BUFFER  *PrmContextBuffer;
 
-  DEBUG ((DEBUG_INFO, "    %a %a - Entry.\n", _DBGMSGID_, __FUNCTION__));
+  DEBUG ((DEBUG_INFO, "    %a %a - Entry.\n", _DBGMSGID_, __func__));
 
   if ((Guid == NULL) || (PrmModuleContextBuffers == NULL)) {
@@ -123,5 +123,5 @@
             "      %a %a: Found a PRM configuration protocol for PRM module %g.\n",
             _DBGMSGID_,
-            __FUNCTION__,
+            __func__,
             Guid
             ));
@@ -144,5 +144,5 @@
     "      %a %a: Could not locate a PRM configuration protocol for PRM handler %g.\n",
     _DBGMSGID_,
-    __FUNCTION__,
+    __func__,
     Guid
     ));
@@ -177,5 +177,5 @@
   CONST PRM_MODULE_CONTEXT_BUFFERS  *ContextBuffers;
 
-  DEBUG ((DEBUG_INFO, "    %a %a - Entry.\n", _DBGMSGID_, __FUNCTION__));
+  DEBUG ((DEBUG_INFO, "    %a %a - Entry.\n", _DBGMSGID_, __func__));
 
   if ((PrmHandlerGuid == NULL) || (PrmContextBuffer == NULL)) {
Index: trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/Library/DxePrmContextBufferLib/UnitTest/DxePrmContextBufferLibUnitTest.c
===================================================================
--- trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/Library/DxePrmContextBufferLib/UnitTest/DxePrmContextBufferLibUnitTest.c	(revision 101283)
+++ trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/Library/DxePrmContextBufferLib/UnitTest/DxePrmContextBufferLibUnitTest.c	(revision 101291)
@@ -385,5 +385,5 @@
     UT_LOG_INFO (
       "%a: Searching by %a GUID ({%g}) returned ContextBuffers at 0x%x\n",
-      __FUNCTION__,
+      __func__,
       ((TestContext->GuidSearchType == ByModuleGuid) ? "module" : "handler"),
       TestContext->Guid,
Index: trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/Library/DxePrmContextBufferLib/UnitTest/DxePrmContextBufferLibUnitTestHost.inf
===================================================================
--- trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/Library/DxePrmContextBufferLib/UnitTest/DxePrmContextBufferLibUnitTestHost.inf	(revision 101283)
+++ trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/Library/DxePrmContextBufferLib/UnitTest/DxePrmContextBufferLibUnitTestHost.inf	(revision 101291)
@@ -18,5 +18,5 @@
 # The following information is for reference only and not required by the build tools.
 #
-#  VALID_ARCHITECTURES           = IA32 X64 ARM AARCH64
+#  VALID_ARCHITECTURES           = IA32 X64
 #
 
Index: trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/Library/DxePrmModuleDiscoveryLib/DxePrmModuleDiscoveryLib.c
===================================================================
--- trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/Library/DxePrmModuleDiscoveryLib/DxePrmModuleDiscoveryLib.c	(revision 101283)
+++ trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/Library/DxePrmModuleDiscoveryLib/DxePrmModuleDiscoveryLib.c	(revision 101291)
@@ -49,5 +49,5 @@
   PRM_MODULE_IMAGE_CONTEXT_LIST_ENTRY  *ForwardListEntry;
 
-  DEBUG ((DEBUG_INFO, "%a %a - Entry.\n", _DBGMSGID_, __FUNCTION__));
+  DEBUG ((DEBUG_INFO, "%a %a - Entry.\n", _DBGMSGID_, __func__));
 
   if (ModuleImageContext == NULL) {
@@ -95,5 +95,5 @@
   PRM_MODULE_IMAGE_CONTEXT_LIST_ENTRY  *PrmModuleImageContextListEntry;
 
-  DEBUG ((DEBUG_INFO, "%a %a - Entry.\n", _DBGMSGID_, __FUNCTION__));
+  DEBUG ((DEBUG_INFO, "%a %a - Entry.\n", _DBGMSGID_, __func__));
 
   PrmModuleImageContextListEntry = AllocateZeroPool (sizeof (*PrmModuleImageContextListEntry));
@@ -106,5 +106,5 @@
     "  %a %a: Allocated PrmModuleImageContextListEntry at 0x%x of size 0x%x bytes.\n",
     _DBGMSGID_,
-    __FUNCTION__,
+    __func__,
     (UINTN)PrmModuleImageContextListEntry,
     sizeof (*PrmModuleImageContextListEntry)
@@ -187,5 +187,5 @@
   UINTN                                MmramRangeCount;
 
-  DEBUG ((DEBUG_INFO, "%a %a - Entry.\n", _DBGMSGID_, __FUNCTION__));
+  DEBUG ((DEBUG_INFO, "%a %a - Entry.\n", _DBGMSGID_, __func__));
 
   PrmHandlerCount = 0;
@@ -204,5 +204,5 @@
                   );
   if (EFI_ERROR (Status) && (HandleCount == 0)) {
-    DEBUG ((DEBUG_ERROR, "%a %a: No LoadedImageProtocol instances found!\n", _DBGMSGID_, __FUNCTION__));
+    DEBUG ((DEBUG_ERROR, "%a %a: No LoadedImageProtocol instances found!\n", _DBGMSGID_, __func__));
     return EFI_NOT_FOUND;
   }
@@ -256,5 +256,5 @@
         "%a %a: ImageHandle 0x%016lx is not a valid PE/COFF image. It cannot be considered a PRM module.\n",
         _DBGMSGID_,
-        __FUNCTION__,
+        __func__,
         (EFI_PHYSICAL_ADDRESS)(UINTN)LoadedImageProtocol->ImageBase
         ));
@@ -305,5 +305,5 @@
     PrmHandlerCount += TempPrmModuleImageContext.ExportDescriptor->Header.NumberPrmHandlers;
     PrmModuleCount++;
-    DEBUG ((DEBUG_INFO, "%a %a: New PRM Module inserted into list to be processed.\n", _DBGMSGID_, __FUNCTION__));
+    DEBUG ((DEBUG_INFO, "%a %a: New PRM Module inserted into list to be processed.\n", _DBGMSGID_, __func__));
   }
 
Index: trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/Library/DxePrmModuleDiscoveryLib/UnitTest/DxePrmModuleDiscoveryLibUnitTestHost.inf
===================================================================
--- trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/Library/DxePrmModuleDiscoveryLib/UnitTest/DxePrmModuleDiscoveryLibUnitTestHost.inf	(revision 101283)
+++ trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/Library/DxePrmModuleDiscoveryLib/UnitTest/DxePrmModuleDiscoveryLibUnitTestHost.inf	(revision 101291)
@@ -18,5 +18,5 @@
 # The following information is for reference only and not required by the build tools.
 #
-#  VALID_ARCHITECTURES           = IA32 X64 ARM AARCH64
+#  VALID_ARCHITECTURES           = IA32 X64
 #
 
Index: trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/Library/DxePrmPeCoffLib/DxePrmPeCoffLib.c
===================================================================
--- trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/Library/DxePrmPeCoffLib/DxePrmPeCoffLib.c	(revision 101283)
+++ trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/Library/DxePrmPeCoffLib/DxePrmPeCoffLib.c	(revision 101291)
@@ -52,5 +52,5 @@
   PRM_MODULE_EXPORT_DESCRIPTOR_STRUCT  *TempExportDescriptor;
 
-  DEBUG ((DEBUG_INFO, "%a %a - Entry.\n", _DBGMSGID_, __FUNCTION__));
+  DEBUG ((DEBUG_INFO, "%a %a - Entry.\n", _DBGMSGID_, __func__));
 
   if ((ImageExportDirectory == NULL) ||
@@ -68,5 +68,5 @@
     "  %a %a: %d exported names found in this image.\n",
     _DBGMSGID_,
-    __FUNCTION__,
+    __func__,
     ImageExportDirectory->NumberOfNames
     ));
@@ -86,5 +86,5 @@
       "  %a %a: Export Name[0x%x] - %a.\n",
       _DBGMSGID_,
-      __FUNCTION__,
+      __func__,
       Index,
       CurrentExportName
@@ -102,9 +102,9 @@
         "  %a %a: PRM Module Export Descriptor found. Ordinal = %d.\n",
         _DBGMSGID_,
-        __FUNCTION__,
+        __func__,
         PrmModuleExportDescriptorOrdinal
         ));
       if (PrmModuleExportDescriptorOrdinal >= ImageExportDirectory->NumberOfFunctions) {
-        DEBUG ((DEBUG_ERROR, "%a %a: The PRM Module Export Descriptor ordinal value is invalid.\n", _DBGMSGID_, __FUNCTION__));
+        DEBUG ((DEBUG_ERROR, "%a %a: The PRM Module Export Descriptor ordinal value is invalid.\n", _DBGMSGID_, __func__));
         return EFI_NOT_FOUND;
       }
@@ -113,5 +113,5 @@
       if (TempExportDescriptor->Header.Signature == PRM_MODULE_EXPORT_DESCRIPTOR_SIGNATURE) {
         *ExportDescriptor = TempExportDescriptor;
-        DEBUG ((DEBUG_INFO, "  %a %a: PRM Module Export Descriptor found at 0x%x.\n", _DBGMSGID_, __FUNCTION__, (UINTN)ExportDescriptor));
+        DEBUG ((DEBUG_INFO, "  %a %a: PRM Module Export Descriptor found at 0x%x.\n", _DBGMSGID_, __func__, (UINTN)ExportDescriptor));
       } else {
         DEBUG ((
@@ -119,10 +119,10 @@
           "  %a %a: PRM Module Export Descriptor found at 0x%x but signature check failed.\n",
           _DBGMSGID_,
-          __FUNCTION__,
+          __func__,
           (UINTN)TempExportDescriptor
           ));
       }
 
-      DEBUG ((DEBUG_INFO, "  %a %a: Exiting export iteration since export descriptor found.\n", _DBGMSGID_, __FUNCTION__));
+      DEBUG ((DEBUG_INFO, "  %a %a: Exiting export iteration since export descriptor found.\n", _DBGMSGID_, __func__));
       return EFI_SUCCESS;
     }
@@ -195,5 +195,5 @@
         "%a %a: The machine type for this image is not valid for a PRM module.\n",
         _DBGMSGID_,
-        __FUNCTION__
+        __func__
         ));
       return EFI_UNSUPPORTED;
@@ -209,5 +209,5 @@
   //
   if (OptionalHeaderPtrUnion.Pe32->Signature != EFI_IMAGE_NT_SIGNATURE) {
-    DEBUG ((DEBUG_ERROR, "%a %a: The PE signature is not valid for the current image.\n", _DBGMSGID_, __FUNCTION__));
+    DEBUG ((DEBUG_ERROR, "%a %a: The PE signature is not valid for the current image.\n", _DBGMSGID_, __func__));
     return EFI_UNSUPPORTED;
   }
@@ -238,9 +238,9 @@
     // The directory address overflows
     //
-    DEBUG ((DEBUG_ERROR, "%a %a: The export directory entry in this image results in overflow.\n", _DBGMSGID_, __FUNCTION__));
+    DEBUG ((DEBUG_ERROR, "%a %a: The export directory entry in this image results in overflow.\n", _DBGMSGID_, __func__));
     return EFI_UNSUPPORTED;
   } else {
-    DEBUG ((DEBUG_INFO, "%a %a: Export Directory Entry found in the image at 0x%x.\n", _DBGMSGID_, __FUNCTION__, (UINTN)OptionalHeaderPtrUnion.Pe32));
-    DEBUG ((DEBUG_INFO, "  %a %a: Directory Entry Virtual Address = 0x%x.\n", _DBGMSGID_, __FUNCTION__, DirectoryEntry->VirtualAddress));
+    DEBUG ((DEBUG_INFO, "%a %a: Export Directory Entry found in the image at 0x%x.\n", _DBGMSGID_, __func__, (UINTN)OptionalHeaderPtrUnion.Pe32));
+    DEBUG ((DEBUG_INFO, "  %a %a: Directory Entry Virtual Address = 0x%x.\n", _DBGMSGID_, __func__, DirectoryEntry->VirtualAddress));
 
     ExportDirectory = (EFI_IMAGE_EXPORT_DIRECTORY *)((UINTN)Image + DirectoryEntry->VirtualAddress);
@@ -249,5 +249,5 @@
       "  %a %a: Export Directory Table found successfully at 0x%x. Name address = 0x%x. Name = %a.\n",
       _DBGMSGID_,
-      __FUNCTION__,
+      __func__,
       (UINTN)ExportDirectory,
       ((UINTN)Image + ExportDirectory->Name),
@@ -288,5 +288,5 @@
   UINT16                               Magic;
 
-  DEBUG ((DEBUG_INFO, "    %a %a - Entry.\n", _DBGMSGID_, __FUNCTION__));
+  DEBUG ((DEBUG_INFO, "    %a %a - Entry.\n", _DBGMSGID_, __func__));
 
   if ((Image == NULL) || (PeCoffLoaderImageContext == NULL) || (ImageMajorVersion == NULL) || (ImageMinorVersion == NULL)) {
@@ -321,5 +321,5 @@
         "%a %a: The machine type for this image is not valid for a PRM module.\n",
         _DBGMSGID_,
-        __FUNCTION__
+        __func__
         ));
       return EFI_UNSUPPORTED;
@@ -334,5 +334,5 @@
   //
   if (OptionalHeaderPtrUnion.Pe32->Signature != EFI_IMAGE_NT_SIGNATURE) {
-    DEBUG ((DEBUG_ERROR, "%a %a: The PE signature is not valid for the current image.\n", _DBGMSGID_, __FUNCTION__));
+    DEBUG ((DEBUG_ERROR, "%a %a: The PE signature is not valid for the current image.\n", _DBGMSGID_, __func__));
     return EFI_UNSUPPORTED;
   }
@@ -352,6 +352,6 @@
   }
 
-  DEBUG ((DEBUG_INFO, "      %a %a - Image Major Version: 0x%02x.\n", _DBGMSGID_, __FUNCTION__, *ImageMajorVersion));
-  DEBUG ((DEBUG_INFO, "      %a %a - Image Minor Version: 0x%02x.\n", _DBGMSGID_, __FUNCTION__, *ImageMinorVersion));
+  DEBUG ((DEBUG_INFO, "      %a %a - Image Major Version: 0x%02x.\n", _DBGMSGID_, __func__, *ImageMajorVersion));
+  DEBUG ((DEBUG_INFO, "      %a %a - Image Minor Version: 0x%02x.\n", _DBGMSGID_, __func__, *ImageMinorVersion));
 
   return EFI_SUCCESS;
@@ -405,5 +405,5 @@
       ASSERT (CurrentExportOrdinal < ImageExportDirectory->NumberOfFunctions);
       if (CurrentExportOrdinal >= ImageExportDirectory->NumberOfFunctions) {
-        DEBUG ((DEBUG_ERROR, "  %a %a: The export ordinal value is invalid.\n", _DBGMSGID_, __FUNCTION__));
+        DEBUG ((DEBUG_ERROR, "  %a %a: The export ordinal value is invalid.\n", _DBGMSGID_, __func__));
         break;
       }
Index: trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/PrmConfigDxe/PrmConfigDxe.c
===================================================================
--- trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/PrmConfigDxe/PrmConfigDxe.c	(revision 101283)
+++ trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/PrmConfigDxe/PrmConfigDxe.c	(revision 101291)
@@ -72,5 +72,5 @@
   EFI_GCD_MEMORY_SPACE_DESCRIPTOR  Descriptor;
 
-  DEBUG ((DEBUG_INFO, "%a %a - Entry.\n", _DBGMSGID_, __FUNCTION__));
+  DEBUG ((DEBUG_INFO, "%a %a - Entry.\n", _DBGMSGID_, __func__));
 
   if ((RuntimeMmioRanges == NULL) || (RuntimeMmioRanges->Count == 0)) {
@@ -83,5 +83,5 @@
       "      %a %a: Runtime MMIO Range [%d].\n",
       _DBGMSGID_,
-      __FUNCTION__,
+      __func__,
       Index
       ));
@@ -90,5 +90,5 @@
       "      %a %a: Physical address = 0x%016x. Length = 0x%x.\n",
       _DBGMSGID_,
-      __FUNCTION__,
+      __func__,
       RuntimeMmioRanges->Range[Index].PhysicalBaseAddress,
       RuntimeMmioRanges->Range[Index].Length
@@ -142,5 +142,5 @@
         "      %a %a: Error [%r] finding descriptor for runtime memory range 0x%016x.\n",
         _DBGMSGID_,
-        __FUNCTION__,
+        __func__,
         Status,
         RuntimeMmioRanges->Range[Index].PhysicalBaseAddress
@@ -164,10 +164,10 @@
         "      %a %a: Error [%r] setting descriptor for runtime memory range 0x%016x.\n",
         _DBGMSGID_,
-        __FUNCTION__,
+        __func__,
         Status,
         RuntimeMmioRanges->Range[Index].PhysicalBaseAddress
         ));
     } else {
-      DEBUG ((DEBUG_INFO, "      %a %a: Successfully set runtime attribute for the MMIO range.\n", _DBGMSGID_, __FUNCTION__));
+      DEBUG ((DEBUG_INFO, "      %a %a: Successfully set runtime attribute for the MMIO range.\n", _DBGMSGID_, __func__));
     }
   }
@@ -190,5 +190,5 @@
   PRM_CONFIG_PROTOCOL  *PrmConfigProtocol;
 
-  DEBUG ((DEBUG_INFO, "%a %a - Entry.\n", _DBGMSGID_, __FUNCTION__));
+  DEBUG ((DEBUG_INFO, "%a %a - Entry.\n", _DBGMSGID_, __func__));
 
   RangeIndex = 0;
@@ -200,5 +200,5 @@
       "  %a %a: Memory allocation for runtime MMIO pointer array failed.\n",
       _DBGMSGID_,
-      __FUNCTION__
+      __func__
       ));
     ASSERT (FALSE);
@@ -233,5 +233,5 @@
             "  %a %a: Index out of bounds - Actual count (%d) of runtime MMIO ranges exceeds maximum count (%d).\n",
             _DBGMSGID_,
-            __FUNCTION__,
+            __func__,
             RangeIndex + 1,
             mMaxRuntimeMmioRangeCount
@@ -249,5 +249,5 @@
       "  %a %a: %d MMIO ranges buffers saved for future virtual memory conversion.\n",
       _DBGMSGID_,
-      __FUNCTION__,
+      __func__,
       RangeIndex
       ));
@@ -278,10 +278,10 @@
 
   if (PrmDataBuffer->Header.Signature != PRM_DATA_BUFFER_HEADER_SIGNATURE) {
-    DEBUG ((DEBUG_ERROR, "  %a %a: The PRM data buffer signature is invalid. PRM module.\n", _DBGMSGID_, __FUNCTION__));
+    DEBUG ((DEBUG_ERROR, "  %a %a: The PRM data buffer signature is invalid. PRM module.\n", _DBGMSGID_, __func__));
     return EFI_NOT_FOUND;
   }
 
   if (PrmDataBuffer->Header.Length < sizeof (PRM_DATA_BUFFER_HEADER)) {
-    DEBUG ((DEBUG_ERROR, "  %a %a: The PRM data buffer length is invalid.\n", _DBGMSGID_, __FUNCTION__));
+    DEBUG ((DEBUG_ERROR, "  %a %a: The PRM data buffer length is invalid.\n", _DBGMSGID_, __func__));
     return EFI_BUFFER_TOO_SMALL;
   }
@@ -312,10 +312,10 @@
 
   if (PrmContextBuffer->Signature != PRM_CONTEXT_BUFFER_SIGNATURE) {
-    DEBUG ((DEBUG_ERROR, "  %a %a: The PRM context buffer signature is invalid.\n", _DBGMSGID_, __FUNCTION__));
+    DEBUG ((DEBUG_ERROR, "  %a %a: The PRM context buffer signature is invalid.\n", _DBGMSGID_, __func__));
     return EFI_NOT_FOUND;
   }
 
   if (IsZeroGuid (&PrmContextBuffer->HandlerGuid)) {
-    DEBUG ((DEBUG_ERROR, "  %a %a: The PRM context buffer GUID is zero.\n", _DBGMSGID_, __FUNCTION__));
+    DEBUG ((DEBUG_ERROR, "  %a %a: The PRM context buffer GUID is zero.\n", _DBGMSGID_, __func__));
     return EFI_NOT_FOUND;
   }
@@ -326,5 +326,5 @@
       "    %a %a: Error in static buffer for PRM handler %g.\n",
       _DBGMSGID_,
-      __FUNCTION__,
+      __func__,
       &PrmContextBuffer->HandlerGuid
       ));
@@ -388,5 +388,5 @@
   PRM_CONFIG_PROTOCOL  *PrmConfigProtocol;
 
-  DEBUG ((DEBUG_INFO, "%a %a - Entry.\n", _DBGMSGID_, __FUNCTION__));
+  DEBUG ((DEBUG_INFO, "%a %a - Entry.\n", _DBGMSGID_, __func__));
 
   HandleBuffer = NULL;
@@ -414,9 +414,9 @@
         "  %a %a: Found PRM configuration protocol for PRM module %g.\n",
         _DBGMSGID_,
-        __FUNCTION__,
+        __func__,
         &PrmConfigProtocol->ModuleContextBuffers.ModuleGuid
         ));
 
-      DEBUG ((DEBUG_INFO, "      %a %a: Validating module context buffers...\n", _DBGMSGID_, __FUNCTION__));
+      DEBUG ((DEBUG_INFO, "      %a %a: Validating module context buffers...\n", _DBGMSGID_, __func__));
       for (BufferIndex = 0; BufferIndex < PrmConfigProtocol->ModuleContextBuffers.BufferCount; BufferIndex++) {
         CurrentContextBuffer = &(PrmConfigProtocol->ModuleContextBuffers.Buffer[BufferIndex]);
@@ -428,5 +428,5 @@
             "        %a %a: Context buffer validation failed for PRM handler %g.\n",
             _DBGMSGID_,
-            __FUNCTION__,
+            __func__,
             CurrentContextBuffer->HandlerGuid
             ));
@@ -434,5 +434,5 @@
       }
 
-      DEBUG ((DEBUG_INFO, "      %a %a: Module context buffer validation complete.\n", _DBGMSGID_, __FUNCTION__));
+      DEBUG ((DEBUG_INFO, "      %a %a: Module context buffer validation complete.\n", _DBGMSGID_, __func__));
 
       if (PrmConfigProtocol->ModuleContextBuffers.RuntimeMmioRanges != NULL) {
@@ -441,5 +441,5 @@
           "    %a %a: Found %d PRM runtime MMIO ranges.\n",
           _DBGMSGID_,
-          __FUNCTION__,
+          __func__,
           PrmConfigProtocol->ModuleContextBuffers.RuntimeMmioRanges->Count
           ));
@@ -479,5 +479,5 @@
   EFI_EVENT   Event;
 
-  DEBUG ((DEBUG_INFO, "%a %a - Entry.\n", _DBGMSGID_, __FUNCTION__));
+  DEBUG ((DEBUG_INFO, "%a %a - Entry.\n", _DBGMSGID_, __func__));
 
   //
Index: trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/PrmLoaderDxe/PrmLoaderDxe.c
===================================================================
--- trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/PrmLoaderDxe/PrmLoaderDxe.c	(revision 101283)
+++ trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/PrmLoaderDxe/PrmLoaderDxe.c	(revision 101291)
@@ -74,5 +74,5 @@
   UINT64  HandlerPhysicalAddress;
 
-  DEBUG ((DEBUG_INFO, "%a %a - Entry.\n", _DBGMSGID_, __FUNCTION__));
+  DEBUG ((DEBUG_INFO, "%a %a - Entry.\n", _DBGMSGID_, __func__));
 
   if (PrmAcpiDescriptionTable == NULL) {
@@ -90,11 +90,11 @@
       "  %a %a: The Platform GUID in the DSC file must be set to a unique non-zero value.\n",
       _DBGMSGID_,
-      __FUNCTION__
+      __func__
       ));
     ASSERT (!CompareGuid (&gEdkiiDscPlatformGuid, &gZeroGuid));
   }
 
-  DEBUG ((DEBUG_INFO, "  %a %a: %d total PRM modules to process.\n", _DBGMSGID_, __FUNCTION__, mPrmModuleCount));
-  DEBUG ((DEBUG_INFO, "  %a %a: %d total PRM handlers to process.\n", _DBGMSGID_, __FUNCTION__, mPrmHandlerCount));
+  DEBUG ((DEBUG_INFO, "  %a %a: %d total PRM modules to process.\n", _DBGMSGID_, __func__, mPrmModuleCount));
+  DEBUG ((DEBUG_INFO, "  %a %a: %d total PRM handlers to process.\n", _DBGMSGID_, __func__, mPrmHandlerCount));
 
   PrmAcpiDescriptionTableBufferSize = (UINT32)(OFFSET_OF (PRM_ACPI_DESCRIPTION_TABLE, PrmModuleInfoStructure) +
@@ -102,5 +102,5 @@
                                                (sizeof (PRM_HANDLER_INFORMATION_STRUCT) * mPrmHandlerCount)
                                                );
-  DEBUG ((DEBUG_INFO, "  %a %a: Total PRM ACPI table size: 0x%x.\n", _DBGMSGID_, __FUNCTION__, PrmAcpiDescriptionTableBufferSize));
+  DEBUG ((DEBUG_INFO, "  %a %a: Total PRM ACPI table size: 0x%x.\n", _DBGMSGID_, __func__, PrmAcpiDescriptionTableBufferSize));
 
   PrmAcpiTable = AllocateZeroPool ((UINTN)PrmAcpiDescriptionTableBufferSize);
@@ -140,5 +140,5 @@
       "  %a %a: PRM Module - %a with %d handlers.\n",
       _DBGMSGID_,
-      __FUNCTION__,
+      __func__,
       (CHAR8 *)((UINTN)CurrentImageAddress + CurrentImageExportDirectory->Name),
       CurrentExportDescriptorStruct->Header.NumberPrmHandlers
@@ -213,5 +213,5 @@
           "    %a %a: Found %a handler physical address at 0x%016x.\n",
           _DBGMSGID_,
-          __FUNCTION__,
+          __func__,
           CurrentExportDescriptorHandlerName,
           CurrentHandlerInfoStruct->PhysicalAddress
@@ -280,5 +280,5 @@
                                   );
     if (!EFI_ERROR (Status)) {
-      DEBUG ((DEBUG_INFO, "%a %a: The PRMT ACPI table was installed successfully.\n", _DBGMSGID_, __FUNCTION__));
+      DEBUG ((DEBUG_INFO, "%a %a: The PRMT ACPI table was installed successfully.\n", _DBGMSGID_, __func__));
     }
   }
@@ -317,5 +317,5 @@
   PRM_ACPI_DESCRIPTION_TABLE  *PrmAcpiDescriptionTable;
 
-  DEBUG ((DEBUG_INFO, "%a %a - Entry.\n", _DBGMSGID_, __FUNCTION__));
+  DEBUG ((DEBUG_INFO, "%a %a - Entry.\n", _DBGMSGID_, __func__));
 
   Status = DiscoverPrmModules (&mPrmModuleCount, &mPrmHandlerCount);
@@ -355,5 +355,5 @@
   EFI_EVENT   EndOfDxeEvent;
 
-  DEBUG ((DEBUG_INFO, "%a %a - Entry.\n", _DBGMSGID_, __FUNCTION__));
+  DEBUG ((DEBUG_INFO, "%a %a - Entry.\n", _DBGMSGID_, __func__));
 
   //
@@ -370,5 +370,5 @@
                   );
   if (EFI_ERROR (Status)) {
-    DEBUG ((DEBUG_ERROR, "%a %a: EndOfDxe callback registration failed! %r.\n", _DBGMSGID_, __FUNCTION__, Status));
+    DEBUG ((DEBUG_ERROR, "%a %a: EndOfDxe callback registration failed! %r.\n", _DBGMSGID_, __func__, Status));
     ASSERT_EFI_ERROR (Status);
   }
Index: trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/PrmSsdtInstallDxe/PrmSsdtInstallDxe.c
===================================================================
--- trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/PrmSsdtInstallDxe/PrmSsdtInstallDxe.c	(revision 101283)
+++ trunk/src/VBox/Devices/EFI/FirmwareNew/PrmPkg/PrmSsdtInstallDxe/PrmSsdtInstallDxe.c	(revision 101291)
@@ -43,5 +43,5 @@
   EFI_ACPI_DESCRIPTION_HEADER  *Ssdt;
 
-  DEBUG ((DEBUG_INFO, "%a %a - Entry.\n", _DBGMSGID_, __FUNCTION__));
+  DEBUG ((DEBUG_INFO, "%a %a - Entry.\n", _DBGMSGID_, __func__));
 
   if (OemId == NULL) {
@@ -62,5 +62,5 @@
                 );
     ASSERT_EFI_ERROR (Status);
-    DEBUG ((DEBUG_INFO, "%a %a: SSDT loaded...\n", _DBGMSGID_, __FUNCTION__));
+    DEBUG ((DEBUG_INFO, "%a %a: SSDT loaded...\n", _DBGMSGID_, __func__));
 
     //